
#ifndef _TTCAN_DEVICE_H
#define _TTCAN_DEVICE_H

#include <string>
#include <vector>
#include <windows.h>
#include "TTCANApi.h"

#ifndef sprintf_s
#define sprintf_s sprintf
#endif

/////////////////////////////////////////////////////////////////////////////
// Definitions

const char TTCAN_DRIVER_MASKNAME[] = "\\\\.\\TTCAN%d";

#define TTCAN_LIB_NUMOF_RETRIES 5

/////////////////////////////////////////////////////////////////////////////
// Class TTCCANDevice

class TTCCANDevice{

// Construction
public:
  TTCCANDevice();
  virtual ~TTCCANDevice();

// Open / Close
public:
  BOOL Open(int nIndex);
  BOOL IsOpen() { return m_bOpen; }
  void Close();
  void Attach(HANDLE hDevice);
  HANDLE Detach();

// Operations
public:
  BOOL GetDatabufSize(UINT32 *pBufSize);
  BOOL GetDatabufPhysAddr(UINT32 *pBufAddr);
  BOOL GetBarPhysAddr(UINT32 *pBarAddr);
  BOOL GetRevision(UINT32 *pRevision);
  BOOL GetPCILocation(UINT32 *pBus, UINT32 *pSlot);
  BOOL GetDriverCompileDate(std::string *pStr);

// Imlpementation
protected:
  BOOL ProcessDeviceIOControl(
    UINT32 dwIoControlCode,
    LPVOID lpInBuffer,
    UINT32 nInBufferSize,
    LPVOID lpOutBuffer,
    UINT32 nOutBufferSize,
    LPDWORD lpBytesReturned,
    UINT32 nTimeoutMs = INFINITE);

  BOOL m_bOpen;
  HANDLE m_hDevice;
  BOOL m_bOverlapped;
  OVERLAPPED m_ReadOverlapped;
  OVERLAPPED m_IOOverlapped;
  int m_nIndex;
  UINT32 m_nDeviceType;

  UINT8  m_simDeviceVersion;
};

#endif
